// Camera.cpp
/************************************************************************
	Lv`֌W̊֐
************************************************************************/
#include <windows.h>
#include <vfw.h>
#include "Resource/resource.h"
#include "Class/CmvAutoLang.hpp"
#include "mymacro.h"
#include "Camera.h"
#include "global.h"

////////////////////////////////////////////////////////////////////////
//  p`
BOOL CaptureCamera (HWND hWnd)
{
	if (gApp.hwndCapture)
	{
		// J摜Lv`
		capCaptureSingleFrame (gApp.hwndCapture);
		return (TRUE);
	}
	return (FALSE);
}

////////////////////////////////////////////////////////////////////////
// J̏擾
BOOL GetCameraCaps (BITMAPINFO *bmi)
{
	if (gApp.hwndCapture)
	{
		capGetVideoFormat (gApp.hwndCapture, bmi, sizeof (BITMAPINFO));
		return (TRUE);
	}
	return (FALSE);
}

////////////////////////////////////////////////////////////////////////
// Be̓xɃR[R[obN֐
static LRESULT PASCAL fpFrameCallback (HWND hWnd, LPVIDEOHDR lpVHdr)
{
	memcpy (
			gApp.cScrn->GetBit (),
			lpVHdr->lpData,
			gApp.cScrn->GetWidth () * gApp.cScrn->GetHeight () * 3);

	return TRUE;
}

////////////////////////////////////////////////////////////////////////
// Lv`̏
BOOL InitializeCamera (HWND hWndParent)
{
	if (gCfg.uiDevice == IDM_DEVICE_MOUSE)
		return (FALSE);

	// Ȏ͔j
	if (gApp.hwndCapture)
		FinalizeCamera (NULL);

	// Lv`EBhD𐶐
	gApp.hwndCapture = capCreateCaptureWindow (NULL, WS_POPUP, 0,0, 0,0, hWndParent, NULL);
	if (gApp.hwndCapture)
	{
		ShowWindow (gApp.hwndCapture, SW_HIDE);

		// ڑ
		UINT id = gCfg.uiDevice - IDM_DEVICE_MOUSE - 1;
		if (capDriverConnect (gApp.hwndCapture, id))
		{
			// vr[[hœ
			capOverlay (gApp.hwndCapture, FALSE);
			capPreview (gApp.hwndCapture, FALSE);
			// EBhDTCYɍ킹ĐLȂ
			capPreviewScale (gApp.hwndCapture, FALSE);
			// VbgBe
			capCaptureSingleFrameOpen (gApp.hwndCapture);
			// R[obNݒ
			capSetCallbackOnFrame (gApp.hwndCapture, fpFrameCallback);

			return (TRUE);
		}
	}

	// Lv`JnłȂ
	gCfg.uiDevice = IDM_DEVICE_MOUSE;
	char buf [BUFSIZE];
	if (LoadString (gApp.hInstance, AUTOLANG (IDS_ERR_START_DEVICE), buf, sizeof (buf)))
		MessageBox (hWndParent, buf, APPLI_NAME, MB_OK | MB_ICONEXCLAMATION);

	return (FALSE);
}

////////////////////////////////////////////////////////////////////////
// Lv`foCX̌n
BOOL FinalizeCamera (HWND hWndParent)
{
	if (gApp.hwndCapture)
	{
		// VbgBeI
		capCaptureSingleFrameClose (gApp.hwndCapture);
		// foCX
		capDriverDisconnect (gApp.hwndCapture);

		DestroyWindow (gApp.hwndCapture);
		gApp.hwndCapture = NULL;
	}
	return (FALSE);
}

/*EOF*/