// CmvIniFile.hpp
/**********************************************************************
	CmvIniFile - t@CɂAvP[V̓o
 **********************************************************************/
#ifndef __CINIFILE_CLASS_HEADER_INCLUDED__
#define __CINIFILE_CLASS_HEADER_INCLUDED__

/************************************************************************
	include files
************************************************************************/
#include <windows.h>
#include "CmvProfile.hpp"

/************************************************************************
	declaration - CmvIniFile
************************************************************************/
class CmvIniFile : public CmvProfile
{
public: // method
	CmvIniFile (LPCTSTR filename)
			: CmvProfile (filename) { NULL; }
	virtual ~CmvIniFile () { NULL; }

	virtual BOOL ReadInt (LPCTSTR section, LPCTSTR entry, LPDWORD data, DWORD default_value = 0);
	virtual BOOL ReadStr (LPCTSTR section, LPCTSTR entry, LPSTR data, LPSTR default_value = "");
	virtual BOOL WriteInt (LPCTSTR section, LPCTSTR entry, LPDWORD data);
	virtual BOOL WriteStr (LPCTSTR section, LPCTSTR entry, LPSTR data);

	virtual BOOL Delete (LPCTSTR section = NULL, LPCTSTR value = NULL);

	virtual BOOL Flush ();
};

#endif // __CINIFILE_CLASS_HEADER_INCLUDED__

// EOF