// Color.cpp
/************************************************************************
	Fo̕ϊ
************************************************************************/
#include <windows.h>
#include "Color.h"

////////////////////////////////////////////////////////////////////////
// F̖OavZs
static UINT32 Saturate2Byte (INT32 n)
{
	if (n < 0)
		return (0);
	if ((255 << 20) < n)
		return (255 << 20);
	return ((UINT32) n);
}

////////////////////////////////////////////////////////////////////////
// RGB->LMS, LMS->RGB ̕ϊs "FohL\tg(FƐFԂ4)" QlɂB
// http://www.hirax.net/dekirukana2/color3/
void ConvertColors (LPBYTE lpbBit, int width,int height, double dL,double dM,double dS, BOOL sup)
{
	INT32 lL = (INT32) (dL * 1024); // scale = 10
	INT32 lM = (INT32) (dM * 1024);
	INT32 lS = (INT32) (dS * 1024);

	if (sup)
	{
		// ϒlɂ⊮F
		for (UINT i = width * height * 3; i; i-=3, lpbBit+=3)
		{
			INT32 rgbB = (INT32) *(lpbBit + 0);
			INT32 rgbG = (INT32) *(lpbBit + 1);
			INT32 rgbR = (INT32) *(lpbBit + 2);

			// RGB -> LMS ̊x
			INT32 lms0L = (180497 * rgbR + 512748 * rgbG +   58962 * rgbB) >> 10; // scale = 10
			INT32 lms0M = ( 21764 * rgbR + 415748 * rgbG +   62529 * rgbB) >> 10;
			INT32 lms0S = (     0 * rgbR +  10486 * rgbG + 1038090 * rgbB) >> 10;

			// ̊x悶(ϕ⊮)
			// @see http://www.hirax.net/dekirukana/webcolor3/index.html
			INT32 lms1L = (lms0L * lL + (((lms0M + lms0S) * (1024 - lL)) >> 1)) >> 10; // scale = 10
			INT32 lms1M = (lms0M * lM + (((lms0S + lms0L) * (1024 - lM)) >> 1)) >> 10;
			INT32 lms1S = (lms0S * lS + (((lms0L + lms0M) * (1024 - lS)) >> 1)) >> 10;

			// LMS ̊x -> RGB
			rgbR = ( 6988 * lms1L - 8622 * lms1M +  122 * lms1S); // scale = 20
			rgbG = (- 366 * lms1L + 3039 * lms1M -  162 * lms1S);
			rgbB = (    4 * lms1L -   31 * lms1M + 1036 * lms1S);

			*(lpbBit + 0) = Saturate2Byte (rgbB) >> 20;
			*(lpbBit + 1) = Saturate2Byte (rgbG) >> 20;
			*(lpbBit + 2) = Saturate2Byte (rgbR) >> 20;
		}
	}
	else {
		// ϒlɂ⊮FȂ
		for (UINT i = width * height * 3; i; i-=3, lpbBit+=3)
		{
			INT32 rgbB = (INT32) *(lpbBit + 0);
			INT32 rgbG = (INT32) *(lpbBit + 1);
			INT32 rgbR = (INT32) *(lpbBit + 2);

			// RGB -> LMS ̊x
			INT32 lms0L = (180497 * rgbR + 512748 * rgbG +   58962 * rgbB) >> 10; // scale = 10
			INT32 lms0M = ( 21764 * rgbR + 415748 * rgbG +   62529 * rgbB) >> 10;
			INT32 lms0S = (     0 * rgbR +  10486 * rgbG + 1038090 * rgbB) >> 10;

			// ̊x悶
			INT32 lms1L = (lms0L * lL) >> 10; // scale = 10
			INT32 lms1M = (lms0M * lM) >> 10;
			INT32 lms1S = (lms0S * lS) >> 10;

			// LMS ̊x -> RGB
			rgbR = ( 6988 * lms1L - 8622 * lms1M +  122 * lms1S); // scale = 20
			rgbG = (- 366 * lms1L + 3039 * lms1M -  162 * lms1S);
			rgbB = (    4 * lms1L -   31 * lms1M + 1036 * lms1S);

			*(lpbBit + 0) = Saturate2Byte (rgbB) >> 20;
			*(lpbBit + 1) = Saturate2Byte (rgbG) >> 20;
			*(lpbBit + 2) = Saturate2Byte (rgbR) >> 20;
		}
	}
}
// '05/07/20	Œ菬_ZɕύX

/*EOF*/