// global.h
/************************************************************************
	ϐ錾
************************************************************************/
#ifndef __GLOBAL_HEADER_INCLUDED__
#define __GLOBAL_HEADER_INCLUDED__

#ifdef CREATE_INSTANCE
	#undef	CREATE_INSTANCE
	#define __GLOBAL
	#define INIT_VALUE(x)	=(x)
#else
	#define __GLOBAL		extern
	#define INIT_VALUE(x)
#endif

/************************************************************************
	include files
************************************************************************/
#include <windows.h>
#include "Class/CmvSurface.hpp"
#include "Class/CmvIniFile.hpp"

/************************************************************************
	declarations
************************************************************************/
__GLOBAL struct
{
	HINSTANCE	hInstance;
	CmvSurface	*cScrn;
	HWND		hwndCapture;
	SIZE		rectMinTrackSize;
	SIZE		rectMaxTrackSize;
} gApp;

__GLOBAL struct
{
	CmvIniFile	*ini;

	BOOL		bTopMost;
	UINT		uiType;
	UINT		uiTimerInterval;
	UINT		uiDevice;
} gCfg;

#endif // __GLOBAL_HEADER_INCLUDED__

//*EOG*/