// CmvSurface.cpp
/**********************************************************************
	CmvSurface - T[tFX
 **********************************************************************/
#include <windows.h>

#define CLASS_INSTANCE
#include "CmvSurface.hpp"



/**********************************************************************
	CmvSurface <CONSTRUCTOR>
 **********************************************************************/
CmvSurface::CmvSurface ()
	:	m_hdc (NULL),
		m_hbmp (NULL),
		m_hbmpOld (NULL),
		m_lpv (NULL)
{
	NULL;
}

/**********************************************************************
	CmvSurface <DESTRUCTOR>
 **********************************************************************/
CmvSurface::~CmvSurface ()
{
	Discard ();
}



/**********************************************************************
	CmvSurface <+ public>
 **********************************************************************/
// w肳ꂽTCỸT[tFX쐬
BOOL CmvSurface::Create (int size_x, int size_y, HDC hdcMaster)
{
	Discard ();

	// DC̊m
	if (hdcMaster) {
		m_hdc = CreateCompatibleDC (hdcMaster);
	} else {
		HDC hdcScreen = ::GetDC (HWND_DESKTOP);
		m_hdc = CreateCompatibleDC (hdcScreen);
		ReleaseDC (HWND_DESKTOP, hdcScreen);
	}
	if (! m_hdc) {
		// error 
		return (FALSE);
	}

	// DIBm
	BITMAPINFO bmi = { 0 };
	bmi.bmiHeader.biSize	= sizeof (BITMAPINFOHEADER);
	bmi.bmiHeader.biWidth	= +size_x;
	bmi.bmiHeader.biHeight	= +size_y;		// W_͍
	bmi.bmiHeader.biPlanes	= 1;
	bmi.bmiHeader.biBitCount	= 24;
	bmi.bmiHeader.biCompression	= BI_RGB;
	m_hbmp = CreateDIBSection (NULL, &bmi, DIB_RGB_COLORS, (VOID **) &m_lpv, NULL, 0);	
	m_hbmpOld = (HBITMAP) SelectObject (m_hdc, m_hbmp);

	GetObject (m_hbmp, sizeof (BITMAP), &m_bitmap);

	if (! m_hbmp || ! m_lpv) {
		// error 
		return (FALSE);
	}

	return (TRUE);
}

// w肳ꂽrbg}bṽRs[T[tFX𓾂
BOOL CmvSurface::Create (HBITMAP hbmpMaster, HDC hdcMaster)
{
	// rbg}bv摜̃TCY𓾂
	if (! hbmpMaster) {
		return (FALSE);
	}
	BITMAP bm;
	GetObject (hbmpMaster, sizeof (BITMAP), &bm);

	// TCỸT[tFX쐬
	if (! Create (bm.bmWidth, bm.bmHeight, hdcMaster)) {
		// error
		return (FALSE);
	}

	// `p̃DC̊m
	HDC hdcMem;
	if (hdcMaster) {
		hdcMem = CreateCompatibleDC (hdcMaster);
	} else {
		HDC hdcScreen = ::GetDC (HWND_DESKTOP);
		hdcMem = CreateCompatibleDC (hdcScreen);
		ReleaseDC (HWND_DESKTOP, hdcScreen);
	}
	HBITMAP hbmpOld = (HBITMAP) SelectObject (hdcMem, hbmpMaster);

	// rbg}bv摜Rs[
	::BitBlt (m_hdc, 0,0, bm.bmWidth, bm.bmHeight, hdcMem, 0,0, SRCCOPY);
	SelectObject (hdcMem, hbmpOld);
	DeleteDC (hdcMem);

	return (TRUE);
}

// T[tFXj
BOOL CmvSurface::Discard ()
{
	if (m_hdc) {
		if (m_hbmp) {
			SelectObject (m_hdc, m_hbmpOld);
			DeleteObject (m_hbmp);
			m_hbmp = m_hbmpOld = NULL;
		}
		DeleteDC (m_hdc);
		m_hdc = NULL, m_lpv = NULL;
	}

	return (TRUE);
}



// DCւ̕`
BOOL CmvSurface::BitBlt (HDC hdc, int x,int y, DWORD rop)
{
	return (m_hdc ? ::BitBlt (hdc, x,y, GetWidth (), GetHeight (), m_hdc, 0,0, rop) : FALSE);
}

// EOF
