// CmvSurface.hpp
/**********************************************************************
	CmvSurface - T[tFX
 **********************************************************************/
#ifndef __SURFACE_CLASS_HEADER_INCLUDED__
#define __SURFACE_CLASS_HEADER_INCLUDED__

#include <windows.h>



class CmvSurface
{
public:
	CmvSurface ();
	virtual ~CmvSurface ();

	BOOL	Create (int,int, HDC hdcMaster = NULL);
	BOOL	Create (HBITMAP, HDC hdcMaster = NULL);
	BOOL	Discard ();
	BOOL	BitBlt (HDC hdcDest, int DestX, int DestY, DWORD rop = SRCCOPY);

	int		GetWidth () const { return (m_bitmap.bmWidth); }
	int		GetHeight () const { return (m_bitmap.bmHeight); }

	HDC			GetDC () const { return (m_hdc); }
	HBITMAP		GetBMP () const { return (m_hbmp); }
	LPBYTE		GetBit () const { return (m_lpv); }

public:
	operator HDC () const { return (m_hdc); }
	operator HBITMAP () const { return (m_hbmp); }
	operator LPBYTE () const { return (m_lpv); }

private:
	HDC		m_hdc;
	HBITMAP m_hbmp;
	HBITMAP m_hbmpOld;
	LPBYTE	m_lpv;
	BITMAP	m_bitmap;
};

#endif // __SURFACE_CLASS_HEADER_INCLUDED__

/*EOF*/