// DlgProgramConfig.cpp
/**********************************************************************
	FõJX^ݒ_CAO
 **********************************************************************/
#include <windows.h>
#include <commctrl.h>
#include "Resource/resource.h"
#include "Class/CmvAutoLang.hpp"
#include "mymacro.h"
#include "global.h"

extern LMSTypes arLMSTypes [];

////////////////////////////////////////////////////////////////////////
// Rg[̍XV
static void UpdateCtrlCustomSetting (HWND hWnd)
{
	SendDlgItemMessage (hWnd, IDC_SLIDER_L, TBM_SETPOS,
			(WPARAM) TRUE, (LPARAM) (LONG) (arLMSTypes [CUSTOM_SETTING].dL * 100));
	SendDlgItemMessage (hWnd, IDC_SLIDER_M, TBM_SETPOS,
			(WPARAM) TRUE, (LPARAM) (LONG) (arLMSTypes [CUSTOM_SETTING].dM * 100));
	SendDlgItemMessage (hWnd, IDC_SLIDER_S, TBM_SETPOS,
			(WPARAM) TRUE, (LPARAM) (LONG) (arLMSTypes [CUSTOM_SETTING].dS * 100));

	char value [BUFSIZE];
	wsprintf (value, "%1d.%02d",
			(int) (arLMSTypes [CUSTOM_SETTING].dL * 100.0) / 100, (int) (arLMSTypes [CUSTOM_SETTING].dL * 100) % 100);
	SendDlgItemMessage (hWnd, IDC_VALUE_L, WM_SETTEXT, 0, (LPARAM) value);
	wsprintf (value, "%1d.%02d",
			(int) (arLMSTypes [CUSTOM_SETTING].dM * 100.0) / 100, (int) (arLMSTypes [CUSTOM_SETTING].dM * 100) % 100);
	SendDlgItemMessage (hWnd, IDC_VALUE_M, WM_SETTEXT, 0, (LPARAM) value);
	wsprintf (value, "%1d.%02d",
			(int) (arLMSTypes [CUSTOM_SETTING].dS * 100.0) / 100, (int) (arLMSTypes [CUSTOM_SETTING].dS * 100) % 100);
	SendDlgItemMessage (hWnd, IDC_VALUE_S, WM_SETTEXT, 0, (LPARAM) value);

	SendDlgItemMessage (hWnd, IDC_SUP, BM_SETCHECK, arLMSTypes [CUSTOM_SETTING].bSup, 0);
}

////////////////////////////////////////////////////////////////////////
// bZ[WvV[W
static INT CALLBACK dlgProcCustomSetting (HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uiMsg)
	{
	case WM_INITDIALOG:
		SendDlgItemMessage (hWnd, IDC_SLIDER_L, TBM_SETRANGE, (WPARAM) FALSE, (LPARAM) MAKELONG (0, 100));
		SendDlgItemMessage (hWnd, IDC_SLIDER_M, TBM_SETRANGE, (WPARAM) FALSE, (LPARAM) MAKELONG (0, 100));
		SendDlgItemMessage (hWnd, IDC_SLIDER_S, TBM_SETRANGE, (WPARAM) FALSE, (LPARAM) MAKELONG (0, 100));
		UpdateCtrlCustomSetting (hWnd);
		return (TRUE);

	case WM_HSCROLL:
		arLMSTypes [CUSTOM_SETTING].dL = SendDlgItemMessage (hWnd, IDC_SLIDER_L, TBM_GETPOS, 0,0) / 100.0;
		arLMSTypes [CUSTOM_SETTING].dM = SendDlgItemMessage (hWnd, IDC_SLIDER_M, TBM_GETPOS, 0,0) / 100.0;
		arLMSTypes [CUSTOM_SETTING].dS = SendDlgItemMessage (hWnd, IDC_SLIDER_S, TBM_GETPOS, 0,0) / 100.0;
		UpdateCtrlCustomSetting (hWnd);
		return (TRUE);

	case WM_COMMAND:
		switch (LOWORD (wParam))
		{
		case IDC_SUP:
			arLMSTypes [CUSTOM_SETTING].bSup = (bool) (SendDlgItemMessage (hWnd, IDC_SUP, BM_GETSTATE, 0,0) & BST_CHECKED);
			return (TRUE);

		case IDOK:
			EndDialog (hWnd, TRUE);
			return (TRUE);
		}
		break;

	case WM_SYSCOMMAND:
		switch (wParam)
		{
		case SC_CLOSE:
			EndDialog (hWnd, FALSE);
			return (TRUE);
		}
		break;
	}
	return (FALSE);
}

////////////////////////////////////////////////////////////////////////
// FõJX^ݒ_CAO
int DialogCustomSetting (HWND hWnd)
{
	ASSERT (hWnd);

	return (DialogBox (gApp.hInstance, MAKEINTRESOURCE (AUTOLANG (IDD_CUSTOM)), hWnd, (DLGPROC) dlgProcCustomSetting));
}

/*EOF*/