// DlgProgramConfig.cpp
/**********************************************************************
	ݒ_CAO
 **********************************************************************/
#include <windows.h>
#include <commctrl.h>
#include "Resource/resource.h"
#include "Class/CmvAutoLang.hpp"
#include "mymacro.h"
#include "global.h"



////////////////////////////////////////////////////////////////////////
// Rg[̍XV
static void UpdateCtrlConfig (HWND hWnd)
{
	SendDlgItemMessage (hWnd, IDC_UPDATE, TBM_SETPOS,
			(WPARAM) TRUE, (LPARAM) (LONG) gCfg.uiTimerInterval);

	char value [BUFSIZE];
	wsprintf (value, "%d mSec", gCfg.uiTimerInterval * TIMER_INTERVAL);
	SendDlgItemMessage (hWnd, IDC_VALUE_UPDATE, WM_SETTEXT, 0, (LPARAM) value);
}

////////////////////////////////////////////////////////////////////////
// bZ[WvV[W
static INT CALLBACK dlgProcConfig (HWND hWnd, UINT uiMsg, WPARAM wParam, LPARAM lParam)
{
	static uiTimerInterval;

	switch (uiMsg)
	{
	case WM_INITDIALOG:
		uiTimerInterval = gCfg.uiTimerInterval;
		SendDlgItemMessage (hWnd, IDC_UPDATE, TBM_SETRANGE, (WPARAM) FALSE, (LPARAM) MAKELONG (1, 10));
		UpdateCtrlConfig (hWnd);
		return (TRUE);

	case WM_HSCROLL:
		gCfg.uiTimerInterval = SendDlgItemMessage (hWnd, IDC_UPDATE, TBM_GETPOS, 0,0);
		UpdateCtrlConfig (hWnd);
		return (TRUE);

	case WM_COMMAND:
		switch (LOWORD (wParam))
		{
		case IDOK:
			// `^C}ݒ
			SetTimer (GetParent (hWnd), TIMER_EVENT_ID, gCfg.uiTimerInterval * TIMER_INTERVAL, NULL);

			EndDialog (hWnd, TRUE);
			return (TRUE);
		}
		break;

	case WM_SYSCOMMAND:
		switch (wParam)
		{
		case SC_CLOSE:
			gCfg.uiTimerInterval = uiTimerInterval;

			EndDialog (hWnd, FALSE);
			return (TRUE);
		}
		break;
	}
	return (FALSE);
}

////////////////////////////////////////////////////////////////////////
// ݒ_CAO
int DialogProgramConfig (HWND hWnd)
{
	ASSERT (hWnd);

	return (DialogBox (gApp.hInstance, MAKEINTRESOURCE (AUTOLANG (IDD_CONFIG)), hWnd, (DLGPROC) dlgProcConfig));
}

/*EOF*/